%global tar_version 4.3.0

Name: java-ovirt-engine-sdk4
Version: 4.3.0
Release: 1%{?dist}
Summary: Java SDK for version 4 of the oVirt Engine API
Group: Development/Languages
License: ASL 2.0
URL: http://ovirt.org/wiki/SDK

# This should be a tar file containing the generated source code of the
# SDK, as we can't build and run the generator with the packages
# available in the distribution:
Source0: ovirt-engine-sdk-java-%{tar_version}.tar.gz

# This file is used to perform the build using Ant, because the upstream
# project has build dependencies that make it impossible to build it
# with the packages available in the distribution:
Source1: build.xml

# This file is used to transform the upstream 'pom.xml' file into a
# 'pom-nodeps.xml' file that doesn't have the dependencies of the
# code generator, as those aren't available in the distribution:
Source2: transform-pom.xsl

BuildArch: noarch

BuildRequires: ant
BuildRequires: javapackages-tools
BuildRequires: maven-local
BuildRequires: mvn(com.sun.xml.txw2:txw2)
BuildRequires: mvn(org.apache.httpcomponents:httpclient)
BuildRequires: mvn(org.apache.httpcomponents:httpcore)
BuildRequires: mvn(org.codehaus.jackson:jackson-core-asl)
BuildRequires: mvn(org.codehaus.jackson:jackson-mapper-asl)
BuildRequires: mvn(org.slf4j:slf4j-api)

# The Java packaging tools available in EL7 don't generate the list of
# required Maven dependencies automatically, so we need to include them
# explicitly here:
Requires: mvn(com.sun.xml.txw2:txw2)
Requires: mvn(org.apache.httpcomponents:httpclient)
Requires: mvn(org.apache.httpcomponents:httpcore)
Requires: mvn(org.codehaus.jackson:jackson-core-asl)
Requires: mvn(org.codehaus.jackson:jackson-mapper-asl)
Requires: mvn(org.slf4j:slf4j-api)

%description
This package contains the Java SDK for version 4 of the oVirt Engine
API.

%prep

# Extract the source:
%setup -q -n ovirt-engine-sdk-java-%{tar_version}

%build

# Copy the files required for the Ant build to the extracted SDK
# directory:
cp %{SOURCE1} %{SOURCE2} .

# Populate the lib directory with symlinks to the required dependencies that
# will be used to create the compiler classpath:
mkdir lib
while read jar
do
  ln -s %{_javadir}/${jar}.jar lib
done << __EOF__
httpcomponents/httpclient
httpcomponents/httpcore
jackson/jackson-core-asl
jackson/jackson-mapper-asl
slf4j/api
txw2
__EOF__

# Perform build using Ant:
java -jar %{_javadir}/ant-launcher.jar -f build.xml

%install

# Install the POM without dependencies created during the build process
# and the .jar file:
%mvn_artifact pom-nodeps.xml target/%{name}.jar
%mvn_install

%files -f .mfiles
%dir %{_javadir}/%{name}
%doc README.adoc
%license LICENSE.txt

%changelog
* Thu Apr 7 2016 Juan Hernandez <juan.hernandez@redhat.com> - 4.0.0
- Initial packaging.
